<template>
  <v-card class="pa-3 px-5" width="400">
    <v-row justify="start">
      <div class="text-h6 mt-2 mx-2">Detalles del pago:</div>
    </v-row>
    <v-row justify="start">
      <v-col>
        <div class="roboto text-subtitle-1">Identificador del pago:</div>
        <div class="text-profile roboto">
          {{ paypalOrderDetails.id }}
        </div>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <div class="roboto text-subtitle-1">Monto pagado:</div>
        <div class="text-profile roboto">
          {{ formattedAmount | currency }} USD
        </div>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <div class="roboto text-subtitle-1">Fecha de la transacción:</div>
        <div class="text-profile roboto">
          {{ paypalOrderDetails.create_time | formatDate }}
        </div>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <div class="roboto text-subtitle-1">Hora de la transacción:</div>
        <div class="text-profile roboto">
          {{ paypalOrderDetails.create_time | formatDateHour }}
        </div>
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import paypalSubscriptionsService from "@/services/billing/paypalSubscriptionsService";
import subscriptionService from "@/services/subscriptionService";
import planConstants from "@/utils/planConstants.json";
import moment from "moment";

export default {
  name: "PaypalCheckoutResult",

  components: {},

  data() {
    return {
      planConstants: planConstants,
      paypalCheckoutData: {},
      paypalOrderDetails: {},
      subscription: {},
      clientInfo: {},
    };
  },

  computed: {
    formattedAmount: function () {
      if (this.paypalOrderDetails.purchase_units) {
        var amount =
          this.paypalOrderDetails.purchase_units[0].amount.value.replace(
            ".",
            ","
          );
      }
      return amount;
    },
  },

  created() {
    this.paypalCheckoutData = JSON.parse(
      localStorage.getItem("PaypalCheckoutData")
    );
    this.clientInfo = JSON.parse(localStorage.getItem("clientInfo"));
    this.addPayment();
  },

  methods: {
    addPayment() {
      paypalSubscriptionsService
        .getPaypalOrderDetails(
          this.paypalCheckoutData.orderID,
          this.clientInfo.countryCode
        )
        .then((orderDetails) => {
          this.paypalOrderDetails = orderDetails;
          subscriptionService
            .getCurrentUserSubscription()
            .then((subscription) => {
              this.subscription = subscription;

              let paymentDTO = {
                paymentDate: moment().toISOString(
                  this.paypalOrderDetails.create_time
                ),
                paymentMethod: "PAYPAL_CHECKOUT",
                planId: this.subscription.plan.id,
                buyOrder: this.paypalCheckoutData.orderID,
                amount: this.paypalOrderDetails.purchase_units[0].amount.value,
                paymentMethodData: JSON.stringify(this.paypalOrderDetails),
              };

              subscriptionService
                .addPayment(this.subscription.id, paymentDTO)
                .then((subscription) => (this.subscription = subscription))
                .catch((err) =>
                  this.$log.error(
                    "Error trying to add a payment to subscription - ",
                    err
                  )
                )
                .then(() => (this.isLoading = false));
            })
            .catch((err) => this.$log.error("Unexpected error: ", err))
            .then(() => (this.isLoading = false));
        })
        .catch((err) => this.$log.error("Unexpected error: ", err))
        .then(() => {
          this.isLoading = false;
          localStorage.removeItem("PaypalCheckoutData");
        });
    },
  },
};
</script>
